// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: generationmodule/generationmodule.proto

package openfmb.generationmodule;

/**
 * <pre>
 * Generation control profile
 * </pre>
 *
 * Protobuf type {@code generationmodule.GenerationControlProfile}
 */
public final class GenerationControlProfile extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:generationmodule.GenerationControlProfile)
    GenerationControlProfileOrBuilder {
private static final long serialVersionUID = 0L;
  // Use GenerationControlProfile.newBuilder() to construct.
  private GenerationControlProfile(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private GenerationControlProfile() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new GenerationControlProfile();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationControlProfile_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationControlProfile_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.generationmodule.GenerationControlProfile.class, openfmb.generationmodule.GenerationControlProfile.Builder.class);
  }

  public static final int CONTROLMESSAGEINFO_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ControlMessageInfo controlMessageInfo_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the controlMessageInfo field is set.
   */
  @java.lang.Override
  public boolean hasControlMessageInfo() {
    return controlMessageInfo_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return The controlMessageInfo.
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlMessageInfo getControlMessageInfo() {
    return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlMessageInfoOrBuilder getControlMessageInfoOrBuilder() {
    return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
  }

  public static final int GENERATINGUNIT_FIELD_NUMBER = 2;
  private openfmb.generationmodule.GeneratingUnit generatingUnit_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the generatingUnit field is set.
   */
  @java.lang.Override
  public boolean hasGeneratingUnit() {
    return generatingUnit_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The generatingUnit.
   */
  @java.lang.Override
  public openfmb.generationmodule.GeneratingUnit getGeneratingUnit() {
    return generatingUnit_ == null ? openfmb.generationmodule.GeneratingUnit.getDefaultInstance() : generatingUnit_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.generationmodule.GeneratingUnitOrBuilder getGeneratingUnitOrBuilder() {
    return generatingUnit_ == null ? openfmb.generationmodule.GeneratingUnit.getDefaultInstance() : generatingUnit_;
  }

  public static final int GENERATIONCONTROL_FIELD_NUMBER = 3;
  private openfmb.generationmodule.GenerationControl generationControl_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the generationControl field is set.
   */
  @java.lang.Override
  public boolean hasGenerationControl() {
    return generationControl_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The generationControl.
   */
  @java.lang.Override
  public openfmb.generationmodule.GenerationControl getGenerationControl() {
    return generationControl_ == null ? openfmb.generationmodule.GenerationControl.getDefaultInstance() : generationControl_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.generationmodule.GenerationControlOrBuilder getGenerationControlOrBuilder() {
    return generationControl_ == null ? openfmb.generationmodule.GenerationControl.getDefaultInstance() : generationControl_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (controlMessageInfo_ != null) {
      output.writeMessage(1, getControlMessageInfo());
    }
    if (generatingUnit_ != null) {
      output.writeMessage(2, getGeneratingUnit());
    }
    if (generationControl_ != null) {
      output.writeMessage(3, getGenerationControl());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (controlMessageInfo_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getControlMessageInfo());
    }
    if (generatingUnit_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getGeneratingUnit());
    }
    if (generationControl_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getGenerationControl());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.generationmodule.GenerationControlProfile)) {
      return super.equals(obj);
    }
    openfmb.generationmodule.GenerationControlProfile other = (openfmb.generationmodule.GenerationControlProfile) obj;

    if (hasControlMessageInfo() != other.hasControlMessageInfo()) return false;
    if (hasControlMessageInfo()) {
      if (!getControlMessageInfo()
          .equals(other.getControlMessageInfo())) return false;
    }
    if (hasGeneratingUnit() != other.hasGeneratingUnit()) return false;
    if (hasGeneratingUnit()) {
      if (!getGeneratingUnit()
          .equals(other.getGeneratingUnit())) return false;
    }
    if (hasGenerationControl() != other.hasGenerationControl()) return false;
    if (hasGenerationControl()) {
      if (!getGenerationControl()
          .equals(other.getGenerationControl())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasControlMessageInfo()) {
      hash = (37 * hash) + CONTROLMESSAGEINFO_FIELD_NUMBER;
      hash = (53 * hash) + getControlMessageInfo().hashCode();
    }
    if (hasGeneratingUnit()) {
      hash = (37 * hash) + GENERATINGUNIT_FIELD_NUMBER;
      hash = (53 * hash) + getGeneratingUnit().hashCode();
    }
    if (hasGenerationControl()) {
      hash = (37 * hash) + GENERATIONCONTROL_FIELD_NUMBER;
      hash = (53 * hash) + getGenerationControl().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.generationmodule.GenerationControlProfile parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.GenerationControlProfile parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.generationmodule.GenerationControlProfile prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Generation control profile
   * </pre>
   *
   * Protobuf type {@code generationmodule.GenerationControlProfile}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:generationmodule.GenerationControlProfile)
      openfmb.generationmodule.GenerationControlProfileOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationControlProfile_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationControlProfile_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.generationmodule.GenerationControlProfile.class, openfmb.generationmodule.GenerationControlProfile.Builder.class);
    }

    // Construct using openfmb.generationmodule.GenerationControlProfile.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      controlMessageInfo_ = null;
      if (controlMessageInfoBuilder_ != null) {
        controlMessageInfoBuilder_.dispose();
        controlMessageInfoBuilder_ = null;
      }
      generatingUnit_ = null;
      if (generatingUnitBuilder_ != null) {
        generatingUnitBuilder_.dispose();
        generatingUnitBuilder_ = null;
      }
      generationControl_ = null;
      if (generationControlBuilder_ != null) {
        generationControlBuilder_.dispose();
        generationControlBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationControlProfile_descriptor;
    }

    @java.lang.Override
    public openfmb.generationmodule.GenerationControlProfile getDefaultInstanceForType() {
      return openfmb.generationmodule.GenerationControlProfile.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.generationmodule.GenerationControlProfile build() {
      openfmb.generationmodule.GenerationControlProfile result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.generationmodule.GenerationControlProfile buildPartial() {
      openfmb.generationmodule.GenerationControlProfile result = new openfmb.generationmodule.GenerationControlProfile(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.generationmodule.GenerationControlProfile result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.controlMessageInfo_ = controlMessageInfoBuilder_ == null
            ? controlMessageInfo_
            : controlMessageInfoBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.generatingUnit_ = generatingUnitBuilder_ == null
            ? generatingUnit_
            : generatingUnitBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.generationControl_ = generationControlBuilder_ == null
            ? generationControl_
            : generationControlBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.generationmodule.GenerationControlProfile) {
        return mergeFrom((openfmb.generationmodule.GenerationControlProfile)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.generationmodule.GenerationControlProfile other) {
      if (other == openfmb.generationmodule.GenerationControlProfile.getDefaultInstance()) return this;
      if (other.hasControlMessageInfo()) {
        mergeControlMessageInfo(other.getControlMessageInfo());
      }
      if (other.hasGeneratingUnit()) {
        mergeGeneratingUnit(other.getGeneratingUnit());
      }
      if (other.hasGenerationControl()) {
        mergeGenerationControl(other.getGenerationControl());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getControlMessageInfoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getGeneratingUnitFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getGenerationControlFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ControlMessageInfo controlMessageInfo_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder> controlMessageInfoBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the controlMessageInfo field is set.
     */
    public boolean hasControlMessageInfo() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return The controlMessageInfo.
     */
    public openfmb.commonmodule.ControlMessageInfo getControlMessageInfo() {
      if (controlMessageInfoBuilder_ == null) {
        return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
      } else {
        return controlMessageInfoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlMessageInfo(openfmb.commonmodule.ControlMessageInfo value) {
      if (controlMessageInfoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        controlMessageInfo_ = value;
      } else {
        controlMessageInfoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlMessageInfo(
        openfmb.commonmodule.ControlMessageInfo.Builder builderForValue) {
      if (controlMessageInfoBuilder_ == null) {
        controlMessageInfo_ = builderForValue.build();
      } else {
        controlMessageInfoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeControlMessageInfo(openfmb.commonmodule.ControlMessageInfo value) {
      if (controlMessageInfoBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          controlMessageInfo_ != null &&
          controlMessageInfo_ != openfmb.commonmodule.ControlMessageInfo.getDefaultInstance()) {
          getControlMessageInfoBuilder().mergeFrom(value);
        } else {
          controlMessageInfo_ = value;
        }
      } else {
        controlMessageInfoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearControlMessageInfo() {
      bitField0_ = (bitField0_ & ~0x00000001);
      controlMessageInfo_ = null;
      if (controlMessageInfoBuilder_ != null) {
        controlMessageInfoBuilder_.dispose();
        controlMessageInfoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlMessageInfo.Builder getControlMessageInfoBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getControlMessageInfoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlMessageInfoOrBuilder getControlMessageInfoOrBuilder() {
      if (controlMessageInfoBuilder_ != null) {
        return controlMessageInfoBuilder_.getMessageOrBuilder();
      } else {
        return controlMessageInfo_ == null ?
            openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder> 
        getControlMessageInfoFieldBuilder() {
      if (controlMessageInfoBuilder_ == null) {
        controlMessageInfoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder>(
                getControlMessageInfo(),
                getParentForChildren(),
                isClean());
        controlMessageInfo_ = null;
      }
      return controlMessageInfoBuilder_;
    }

    private openfmb.generationmodule.GeneratingUnit generatingUnit_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.GeneratingUnit, openfmb.generationmodule.GeneratingUnit.Builder, openfmb.generationmodule.GeneratingUnitOrBuilder> generatingUnitBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the generatingUnit field is set.
     */
    public boolean hasGeneratingUnit() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The generatingUnit.
     */
    public openfmb.generationmodule.GeneratingUnit getGeneratingUnit() {
      if (generatingUnitBuilder_ == null) {
        return generatingUnit_ == null ? openfmb.generationmodule.GeneratingUnit.getDefaultInstance() : generatingUnit_;
      } else {
        return generatingUnitBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setGeneratingUnit(openfmb.generationmodule.GeneratingUnit value) {
      if (generatingUnitBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        generatingUnit_ = value;
      } else {
        generatingUnitBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setGeneratingUnit(
        openfmb.generationmodule.GeneratingUnit.Builder builderForValue) {
      if (generatingUnitBuilder_ == null) {
        generatingUnit_ = builderForValue.build();
      } else {
        generatingUnitBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeGeneratingUnit(openfmb.generationmodule.GeneratingUnit value) {
      if (generatingUnitBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          generatingUnit_ != null &&
          generatingUnit_ != openfmb.generationmodule.GeneratingUnit.getDefaultInstance()) {
          getGeneratingUnitBuilder().mergeFrom(value);
        } else {
          generatingUnit_ = value;
        }
      } else {
        generatingUnitBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearGeneratingUnit() {
      bitField0_ = (bitField0_ & ~0x00000002);
      generatingUnit_ = null;
      if (generatingUnitBuilder_ != null) {
        generatingUnitBuilder_.dispose();
        generatingUnitBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.generationmodule.GeneratingUnit.Builder getGeneratingUnitBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getGeneratingUnitFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.generationmodule.GeneratingUnitOrBuilder getGeneratingUnitOrBuilder() {
      if (generatingUnitBuilder_ != null) {
        return generatingUnitBuilder_.getMessageOrBuilder();
      } else {
        return generatingUnit_ == null ?
            openfmb.generationmodule.GeneratingUnit.getDefaultInstance() : generatingUnit_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GeneratingUnit generatingUnit = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.GeneratingUnit, openfmb.generationmodule.GeneratingUnit.Builder, openfmb.generationmodule.GeneratingUnitOrBuilder> 
        getGeneratingUnitFieldBuilder() {
      if (generatingUnitBuilder_ == null) {
        generatingUnitBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.generationmodule.GeneratingUnit, openfmb.generationmodule.GeneratingUnit.Builder, openfmb.generationmodule.GeneratingUnitOrBuilder>(
                getGeneratingUnit(),
                getParentForChildren(),
                isClean());
        generatingUnit_ = null;
      }
      return generatingUnitBuilder_;
    }

    private openfmb.generationmodule.GenerationControl generationControl_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.GenerationControl, openfmb.generationmodule.GenerationControl.Builder, openfmb.generationmodule.GenerationControlOrBuilder> generationControlBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the generationControl field is set.
     */
    public boolean hasGenerationControl() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The generationControl.
     */
    public openfmb.generationmodule.GenerationControl getGenerationControl() {
      if (generationControlBuilder_ == null) {
        return generationControl_ == null ? openfmb.generationmodule.GenerationControl.getDefaultInstance() : generationControl_;
      } else {
        return generationControlBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setGenerationControl(openfmb.generationmodule.GenerationControl value) {
      if (generationControlBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        generationControl_ = value;
      } else {
        generationControlBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setGenerationControl(
        openfmb.generationmodule.GenerationControl.Builder builderForValue) {
      if (generationControlBuilder_ == null) {
        generationControl_ = builderForValue.build();
      } else {
        generationControlBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeGenerationControl(openfmb.generationmodule.GenerationControl value) {
      if (generationControlBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          generationControl_ != null &&
          generationControl_ != openfmb.generationmodule.GenerationControl.getDefaultInstance()) {
          getGenerationControlBuilder().mergeFrom(value);
        } else {
          generationControl_ = value;
        }
      } else {
        generationControlBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearGenerationControl() {
      bitField0_ = (bitField0_ & ~0x00000004);
      generationControl_ = null;
      if (generationControlBuilder_ != null) {
        generationControlBuilder_.dispose();
        generationControlBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.generationmodule.GenerationControl.Builder getGenerationControlBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getGenerationControlFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.generationmodule.GenerationControlOrBuilder getGenerationControlOrBuilder() {
      if (generationControlBuilder_ != null) {
        return generationControlBuilder_.getMessageOrBuilder();
      } else {
        return generationControl_ == null ?
            openfmb.generationmodule.GenerationControl.getDefaultInstance() : generationControl_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.generationmodule.GenerationControl generationControl = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.GenerationControl, openfmb.generationmodule.GenerationControl.Builder, openfmb.generationmodule.GenerationControlOrBuilder> 
        getGenerationControlFieldBuilder() {
      if (generationControlBuilder_ == null) {
        generationControlBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.generationmodule.GenerationControl, openfmb.generationmodule.GenerationControl.Builder, openfmb.generationmodule.GenerationControlOrBuilder>(
                getGenerationControl(),
                getParentForChildren(),
                isClean());
        generationControl_ = null;
      }
      return generationControlBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:generationmodule.GenerationControlProfile)
  }

  // @@protoc_insertion_point(class_scope:generationmodule.GenerationControlProfile)
  private static final openfmb.generationmodule.GenerationControlProfile DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.generationmodule.GenerationControlProfile();
  }

  public static openfmb.generationmodule.GenerationControlProfile getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<GenerationControlProfile>
      PARSER = new com.google.protobuf.AbstractParser<GenerationControlProfile>() {
    @java.lang.Override
    public GenerationControlProfile parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<GenerationControlProfile> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<GenerationControlProfile> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.generationmodule.GenerationControlProfile getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

